# Bakery::App_Gtk Class Reference

This class implements Bakery::App using gtkmm. More...

`#include <App_Gtk.h>`

Inheritance diagram for Bakery::App_Gtk:

[legend]

List of all members.

## Public Types

typedef Gtk::Window | ParentWindow

## Public Member Functions

| App_Gtk (const Glib::ustring &appname)
| Don't forget to call init() too.
| App_Gtk (BaseObjectType *cobject, const Glib::ustring &appname)
| This constructor can be used to implement derived classes for use with Gnome::Glade::Xml::get_derived_widget().
virtual | ~App_Gtk ()
virtual void | add (Gtk::Widget &child)
| Overidden to add a widget in the middle, under the menu, instead of replacing the whole contents.

## Static Public Member Functions

static Glib::ustring | util_bold_message (const Glib::ustring &message)
| For instance, to create bold primary text for a dialog box, without marking the markup for translation.

## Protected Member Functions

virtual void | init ()
virtual void | init_ui_manager ()
| Builds the intial ui string, with placeholders.
virtual void | init_menus ()
| Override this to add more menus or different menus.
virtual void | init_menus_file ()
| Call this from init_menus() to add the standard file menu.
virtual void | init_menus_edit ()
| Call this from init_menus() to add the standard edit menu.
virtual void | init_menus_help ()
| Call this from init_menus() to add the standard help menu.
virtual void | init_toolbars ()
virtual void | init_layout ()
virtual void | add_ui_from_string (const Glib::ustring &ui_description)
virtual void | on_hide ()
virtual void | on_menu_help_about ()
virtual void | on_about_close ()
virtual void | ui_hide ()
virtual void | ui_bring_to_front ()
virtual bool | on_delete_event (GdkEventAny *event)

## Protected Attributes

Glib::RefPtr< Gtk::UIManager > | m_refUIManager
Glib::RefPtr< Gtk::ActionGroup > | m_refFileActionGroup
Glib::RefPtr< Gtk::ActionGroup > | m_refEditActionGroup
Glib::RefPtr< Gtk::ActionGroup > | m_refHelpActionGroup
Gtk::VBox * | m_pVBox
Gtk::VBox | m_VBox_PlaceHolder
Gtk::HandleBox | m_HandleBox_Toolbar

## Static Protected Attributes

static Gtk::Window * | m_pAbout

## Friends

class | AppInstanceManager

## Detailed Description

This class implements Bakery::App using gtkmm.

Features:

- Override methods to add/change menus/toolbars/statusbar.
  - Default is basic File, Edit, Help menus and toolbar icons.

## Member Typedef Documentation

typedef Gtk::Window Bakery::App_Gtk::ParentWindow

## Constructor & Destructor Documentation

Bakery::App_Gtk::App_Gtk | ( | const Glib::ustring & | appname | ) |

Don't forget to call init() too.

Bakery::App_Gtk::App_Gtk | ( | BaseObjectType * | cobject,
|  | const Glib::ustring & | appname |
| ) |  |  |

This constructor can be used to implement derived classes for use with Gnome::Glade::Xml::get_derived_widget().

virtual Bakery::App_Gtk::~App_Gtk | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void Bakery::App_Gtk::add | ( | Gtk::Widget & | child | ) | `[virtual]`

Overidden to add a widget in the middle, under the menu, instead of replacing the whole contents.

Reimplemented from Gtk::Container.

static Glib::ustring Bakery::App_Gtk::util_bold_message | ( | const Glib::ustring & | message | ) | `[static]`

For instance, to create bold primary text for a dialog box, without marking the markup for translation.

virtual void Bakery::App_Gtk::init | ( |  | ) | `[protected, virtual]`

Reimplemented from Bakery::App.

Reimplemented in Bakery::App_WithDoc_Gtk.

virtual void Bakery::App_Gtk::init_ui_manager | ( |  | ) | `[protected, virtual]`

Builds the intial ui string, with placeholders.

This allows us to merge in actual menus and toolbars in the other init_*() methods.

Reimplemented from Bakery::App.

virtual void Bakery::App_Gtk::init_menus | ( |  | ) | `[protected, virtual]`

Override this to add more menus or different menus.

Reimplemented from Bakery::App.

virtual void Bakery::App_Gtk::init_menus_file | ( |  | ) | `[protected, virtual]`

Call this from init_menus() to add the standard file menu.

Implements Bakery::App.

Reimplemented in Bakery::App_WithDoc_Gtk.

virtual void Bakery::App_Gtk::init_menus_edit | ( |  | ) | `[protected, virtual]`

Call this from init_menus() to add the standard edit menu.

Implements Bakery::App.

virtual void Bakery::App_Gtk::init_menus_help | ( |  | ) | `[protected, virtual]`

Call this from init_menus() to add the standard help menu.

Implements Bakery::App.

virtual void Bakery::App_Gtk::init_toolbars | ( |  | ) | `[protected, virtual]`

Reimplemented from Bakery::App.

Reimplemented in Bakery::App_WithDoc_Gtk.

virtual void Bakery::App_Gtk::init_layout | ( |  | ) | `[protected, virtual]`

virtual void Bakery::App_Gtk::add_ui_from_string | ( | const Glib::ustring & | ui_description | ) | `[protected, virtual]`

virtual void Bakery::App_Gtk::on_hide | ( |  | ) | `[protected, virtual]`

Reimplemented from Gtk::Widget.

virtual void Bakery::App_Gtk::on_menu_help_about | ( |  | ) | `[protected, virtual]`

Implements Bakery::App.

virtual void Bakery::App_Gtk::on_about_close | ( |  | ) | `[protected, virtual]`

Reimplemented from Bakery::App.

virtual void Bakery::App_Gtk::ui_hide | ( |  | ) | `[protected, virtual]`

Implements Bakery::App.

virtual void Bakery::App_Gtk::ui_bring_to_front | ( |  | ) | `[protected, virtual]`

Implements Bakery::App.

virtual bool Bakery::App_Gtk::on_delete_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

Reimplemented from Gtk::Widget.

## Friends And Related Function Documentation

friend class AppInstanceManager `[friend]`

Reimplemented from Bakery::App.

## Member Data Documentation

Glib::RefPtr<Gtk::UIManager> Bakery::App_Gtk::m_refUIManager `[protected]`

Glib::RefPtr<Gtk::ActionGroup> Bakery::App_Gtk::m_refFileActionGroup `[protected]`

Glib::RefPtr<Gtk::ActionGroup> Bakery::App_Gtk::m_refEditActionGroup `[protected]`

Glib::RefPtr<Gtk::ActionGroup> Bakery::App_Gtk::m_refHelpActionGroup `[protected]`

Gtk::VBox* Bakery::App_Gtk::m_pVBox `[protected]`

Gtk::VBox Bakery::App_Gtk::m_VBox_PlaceHolder `[protected]`

Gtk::HandleBox Bakery::App_Gtk::m_HandleBox_Toolbar `[protected]`

Gtk::Window* Bakery::App_Gtk::m_pAbout `[static, protected]`

The documentation for this class was generated from the following file:

- App_Gtk.h